""" 
	ceap
	input class
"""

import config, helper
import object

import os, ConfigParser
import pygame
from pygext.gl.all import *
from pygame.locals import *

class InputManager:
	def __init__(self):
		self.ok = False
		self.events = {}
		self.aev = []
		self.showcur = False
		self.cursorobject = None
		self.mouseposition = [0,0]
		self.mousemotion = True
		self.keydown = True
		
	def load(self, file):
		parser = ConfigParser.ConfigParser()
		file = os.path.join(config.DATAPATH, file)
		parser.readfp(open(file))
		if parser.has_option("input", "input_script"):
			inps = parser.get("input", "input_script")
			inps = os.path.join(config.DATAPATH, inps)
			execfile(inps)
		curname = parser.get("input", "cursor")
		self.cursorobject = object.Object(name = curname)
		pygame.mouse.set_visible(False)
		
	def set(self, key, event):
		if key in self.events:
			self.events[key].append(event)
		else:
			self.events[key] = [event]
	
	def enter(self):
		self.handle_keydown(pygame.event.Event(KEYDOWN))
		self.handle_mousemotion(pygame.event.Event(MOUSEMOTION))
		self.handle_mousebuttondown(pygame.event.Event(MOUSEBUTTONDOWN))
		self.ok = True
		
	def exit(self):
		pass
		
	def handle_keydown(self, event):
		self.keydown = True
		self.keys = pygame.key.get_pressed()
		
	def handle_mousemotion(self, event):
		self.mousemotion = True
		self.mouseposition = pygame.mouse.get_pos()
		
	def handle_mousebuttondown(self, event):
		self.keydown = True
		self.mousekeys = pygame.mouse.get_pressed()
		
	def tick(self):
		self.aev = []
		if self.keydown is True:
			for k in self.events.keys():
				if isinstance(k, int):
					if self.keys[k]:
						self.aev += self.events[k]
				if isinstance(k, str):
					for i in range(len(self.mousekeys)):
					 	if self.mousekeys[i]:
					 		self.aev += self.events["MOUSE%i"%(i+1)]
		if self.mousemotion is True and self.showcur is True and self.cursorobject is not None:
			self.cursorobject.set(x = self.mouseposition[0], y = self.mouseposition[1])
		self.mousemotion = False
		self.keydown = False

	def keys(self):
		return self.keys
		
	def mousekeys(self):
		return self.mousekeys
		
	def check(self, event):
		for i in self.aev:
			if str(i) == str(event):
				return True
		
	def mousepos(self):
		return self.mouseposition
		
	def show_cursor(self, show):
		self.showcur = show
		if self.showcur is True and self.cursorobject is not None:
			self.cursorobject.setup()
		elif self.showcur is False and self.cursorobject is not None:
			director.scene.remove(self.cursorobject)
		
		
		
inputman = InputManager()
	