"""
	ceap
	my action classes
"""

from pygext.gl.all import *
import math

class Walk(MoveDelta):
	def __init__(self,  *arg, **kw):
		self.entity = None
		MoveDelta.__init__(self, *arg, **kw)
		
	def init(self, tarx, tary, state = "walk", nextstate = "stand", check_start = True, check_tick = False):
		self.state = state
		self.nextstate = nextstate
		self.tarx = tarx
		self.tary = tary
		self.mode = StopMode
		self.check_start = check_start
		self.check_tick = check_tick
		self.aborted = False
	
	def start(self):
		self.saveentity = self.entity
	
		if self.check_start is True:
			if director.scene.is_walkable((self.tarx, self.tary)) is False:
				self.aborted = True
				self.end()
				return
				
		if self.check_tick is True:
			self.lastx = self.entity.x
			self.lasty = self.entity.y
				
		self.dx = self.tarx - self.entity.x
		self.dy = self.tary - self.entity.y
		d = math.sqrt(self.dx*self.dx + self.dy*self.dy)
		if d == 0.0:
			self.aborted = True
			self.end()
			return

		self.entity.set_state(self.state)

		if self.entity.speed <= 0.0:
			self.secs = d / 200.0
		else:
			self.secs = d / self.entity.speed
		MoveDelta.start(self)
		
	def action(self):
		if self.check_tick is True:
			if director.scene.is_walkable((self.entity.x, self.entity.y)) is False:
				self.entity.set(x = self.lastx, y = self.lasty)
				self.end()
				return
			self.lastx = self.entity.x
			self.lasty = self.entity.y
				
		MoveDelta.action(self)
		
	def cleanup(self):
		if self.aborted is False:
			self.saveentity.set_state(self.nextstate)
