""" 
	ceap
	state base class
"""

import table, os.path
from pygext.gl.all import *

class ObjectState:
	def __init__(self, object, name, anim = None, script = None):
		self.object = object
		self.name = name
		self.anim = anim
		self.arunning = False
		self.script = script
			
	def enter(self):
		if self.anim is not None:
			if self.anim in self.object.anims.keys():
				self.object.do(self.object.anims[self.anim].action)
				self.arunning = True
		if self.script is not None:
			execfile(os.path.join(self.object.path, self.script), {"function": "enter", "self": self})
		
	def tick(self):
		if self.script is not None:
			execfile(os.path.join(self.object.path, self.script), {"function": "tick", "self": self})
			
	def exit(self):
		if self.arunning == True:
			#self.object.anims[self.anim].action.end()
			self.object.end_actions(Animate)
		if self.script is not None:
			execfile(os.path.join(self.object.path, self.script), {"function": "enter", "self": self})

